"""Module contains SHH stage and its dependencies."""

import os
from pathlib import Path
from typing import Optional, Union

from novaclient.exceptions import Conflict, NotFound
from novaclient.v2.keypairs import Keypair

from ..exceptions import ProviderPermanentError, ProviderPermanentErrorReason
from ..settings import SSH
from ..utils.common import exec_cmd
from ..utils.kubernetes import Kubernetes
from ..utils.openstack import OpenStack
from ..utils.state import ProviderState


async def get_public_key(
    private_key: Union[str, bytes, "os.PathLike[str]", "os.PathLike[bytes]"]
) -> str:
    """Generate public ssh key from private.

    Args:
        private_key (str, pathlib.Path): Path to the private key

    Returns:
        str: Public ssh key
    """
    os.chmod(private_key, 0o600)  # Always force the permissions
    public_key, _ = await exec_cmd(["ssh-keygen", "-f", private_key, "-y"], output=True)
    return public_key.decode().strip()


class StageSSH(object):
    """SSH stage class.

    OpenStack SSH access key needs to be created from user and provider public keys.
    Then the provider as well as user can use it in Terraform scripts via TF_VAR_keypair
    and in Ansible playbooks via ansible_ssh_private_key_file.
    Provider private key is stored in secret.

    """

    def __init__(
        self,
        cluster_name: str,
        cluster_namespace: str,
        openstack: OpenStack,
        kubernetes: Kubernetes,
        settings: SSH,
        cluster_path: Path,
        adopt_state: bool,
        user_key: Optional[str] = None,
    ):
        self.cluster_name = cluster_name
        self.cluster_namespace = cluster_namespace
        self.openstack = openstack
        self.kubernetes = kubernetes
        self.settings = settings
        self.cluster_path = cluster_path
        self.adopt_state = adopt_state
        self.user_key = user_key

        self.provider_keypair = "-".join(
            (self.cluster_name, self.settings.provider.keypair)
        )
        self.provider_name = "-".join(
            (self.cluster_name, self.settings.provider.state.name)
        )
        self.provider_path = self.cluster_path / self.settings.provider.state.path

        self.user_keypair = "-".join((self.cluster_name, self.settings.user.keypair))
        self.user_name = "-".join((self.cluster_name, self.settings.user.state.name))
        self.user_path = self.cluster_path / self.settings.user.state.path

        self.keypair_merged = "-".join(
            (self.cluster_name, self.settings.keypair_merged)
        )

    @staticmethod
    def write_private_key(private_key: str, path: Path):
        """Write a private key to the file."""
        os.makedirs(os.path.dirname(path), exist_ok=True)
        with open(path, "w") as key_file:
            key_file.write(private_key)
        os.chmod(path, 0o600)

    def __enter__(self):
        """Load ssh state from secret."""
        self.provider_state = ProviderState(
            k8s=self.kubernetes,
            name=self.provider_name,
            namespace=self.cluster_namespace,
            path=self.provider_path,
            adopt_state=self.adopt_state,
        )
        self.provider_state.load()
        self.user_state = ProviderState(
            k8s=self.kubernetes,
            name=self.user_name,
            namespace=self.cluster_namespace,
            path=self.user_path,
            adopt_state=self.adopt_state,
        )
        self.user_state.load()
        return self

    def __exit__(self, *exc):
        """Update ssh state secret."""
        self.provider_state.update()
        self.user_state.update()

    async def get_keypair(self, keypair: str, state: ProviderState) -> Keypair:
        """Get OpenStack SSH keypair.

        Try to restore SSH key from secret. If SSH path does not exist,
        create SSH keypair in OpenStack and write its private part to the secret.

        Returns:
            Keypair: SSH keypair
        """
        if not state.path.exists():
            # TODO: Add validation webhook for checking
            #  keypairs of user to avoid keypair Conflict
            try:
                _key = self.openstack.create_keypair(keypair)
            except Conflict:
                raise ProviderPermanentError(
                    reason=ProviderPermanentErrorReason.OPENSTACK_KEYPAIR_ERROR.name,  # noqa: E501
                    message=f"Key {keypair} already exists",
                )
            else:
                self.write_private_key(_key.private_key, state.path)

        _key_public = await get_public_key(state.path)

        # OpenStack keypair
        try:
            _key = self.openstack.get_keypair(keypair)
        except NotFound:
            _key = self.openstack.create_keypair(
                keypair,
                # FIXME: If the keypair is generated by OS Nova
                #  than the public part contains comment: `Generated-by-Nova`.
                #  It causes a race condition in case when the keypair
                #  is manually removed from OS and here is the attempt
                #  to re-create it from provider state. Therefore,
                #  as a (ugly) workaround, the expected comment is added.
                public_key=_key_public + " Generated-by-Nova",
            )

        # Validate local state against OpenStack
        if _key_public not in _key.public_key:
            raise ProviderPermanentError(
                reason=ProviderPermanentErrorReason.OPENSTACK_KEYPAIR_ERROR.name,
                message=f"Key {keypair} doesn't match "
                f"key loaded from state {state.name}",
            )

        return _key

    async def get_merged_key(self) -> str:
        """Get merged SSH key.

        Provider uses merged SSH identity, created from user and provider public keys
        to ensure that the access will be granted to both.

        Returns:
            str: Name of merged keypair
        """
        provider_key = await self.get_keypair(
            self.provider_keypair, self.provider_state
        )

        if not self.user_key:
            user_key = await self.get_keypair(self.user_keypair, self.user_state)
        else:
            try:
                user_key = self.openstack.get_keypair(self.user_key)
            except NotFound:
                raise ProviderPermanentError(
                    reason=ProviderPermanentErrorReason.OPENSTACK_KEYPAIR_ERROR.name,
                    message=f"User defined keypair {self.user_key} not found",
                )

        try:
            merged_public_key = provider_key.public_key + "\n" + user_key.public_key
            self.openstack.create_keypair(
                self.keypair_merged,
                public_key=merged_public_key,
            )
        except Conflict:
            self.openstack.logger.debug(
                f"OpenStack: Key {self.keypair_merged} already exists. Let's use it"
            )

        return self.keypair_merged

    async def check_injected_identity(self):
        """Check injected SSH identity assets.

        Raises:
            ProviderPermanentError: When the provider identity related files
                or variables did not exist.

        """
        if not self.provider_state.path.exists():
            raise ProviderPermanentError(
                reason=ProviderPermanentErrorReason.K8S_CAPI_PROVIDER_ERROR.name,
                message=f"Create provider identity flag is set to False."
                " Provider should use injected SSH keypair, which private part "
                f" was not found in {self.provider_state.path}.",
            )

        if not self.user_key:
            raise ProviderPermanentError(
                reason=ProviderPermanentErrorReason.K8S_CAPI_PROVIDER_ERROR.name,
                message="Create provider identity flag is set to False."
                " Provider should use injected SSH keypair, which name"
                " is not defined by variable `TF_VAR_keypair`.",
            )

        try:
            await get_public_key(self.provider_state.path)
        # FIXME: Replace generic `Exception` with a more fine-grained one.
        except Exception as e:
            raise ProviderPermanentError(
                reason=ProviderPermanentErrorReason.K8S_CAPI_PROVIDER_ERROR.name,
                message="Create provider identity flag is set to False."
                " Provider should use injected SSH keypair, which public part"
                f" could not be obtained from private part {str(e)}",
            )

    async def get_environment(self, managed_provider_identity: bool = True) -> dict:
        """Get SSH environment variables.

        Args:
            managed_provider_identity (bool, optional):  True if the SSH
                identity will be created by k8s-capi-provider. The provider
                identity should not be created by k8s-capi-provider when
                the cluster was injected (by `yaookctl inject`) from yaook/k8s LCM.
                Then, the origin yaook/k8s SSH identity (key) is
                used as a provider one and should not be created again.
                Defaults to True.

        Returns:
            dict: SSH environment variables
        """
        if managed_provider_identity:
            return {"TF_VAR_keypair": await self.get_merged_key()}

        return {"TF_VAR_keypair": self.user_key}
